# Linux Kernel Module Cheat
The perfect emulation setup to study and develop the <<linux-kernel>> v5.9.2, kernel modules, <<qemu-buildroot-setup,QEMU>>, <<gem5-buildroot-setup,gem5>> and x86_64, ARMv7 and ARMv8 <<userland-assembly,userland>> and <<baremetal-setup,baremetal>> assembly, <<c,ANSI C>>, <<cpp,C++>> and <<posix,POSIX>>. <<gdb>> and <<kgdb>> just work. Powered by <<about-the-qemu-buildroot-setup,Buildroot>> and <<about-the-baremetal-setup,crosstool-NG>>. Highly automated. Thoroughly documented. Automated <<test-this-repo,tests>>.

###### 27.3.1.1.1. C++ rule of five

userland/cpp/rule_of_five.cpp

Output Ubuntu 20.04 GCC 9.3:

    constructor?
    constructor

    copy?
    constructor
    copy

    copy assignment?
    constructor
    copy assignment
    constructor
    copy
    move assignment
    destructor

    move?
    constructor

    move?
    constructor
    constructor
    move assignment
    destructor

    a bunch of destructors?
    destructor
    destructor
    destructor
    destructor
    destructor

https://en.cppreference.com/w/cpp/language/rule_of_three